dim last64(64) , filtcoef(64)
pi = 3.141592654
cls
locate 1 , 10 : color 14
print "CONVERT REAL DATA FILE (.DAT)  TO .WAV  FILE WITH RESAMPLING"
color 7
locate 3 , 10
if command$ > "" then
	f1$ = command$
else
	files "*.dat"
	print
	input "Real data file   .DAT       ",f1$
end if
cls
z% = instr(f1$ , ".")
f1$ = ucase$(f1$)
if z% = 0 then
	f3$ = f1$ + ".INF"
	f2$ = f1$ + ".WAV"
	f1$ = f1$ + ".DAT"
else
	f2$ = left$(f1$ , z% - 1) + ".WAV"
end if
if dir$(f1$) = "" then sound 300 , 2 : print "No file" : end
locate 9 , 10
if dir$(f3$) > "" then
	open "i" , 1 , f3$
	input #1 , srate%
	close 1
	print "Sampling rate ";srate%
else
	srate% = 10000
end if
if dir$(f2$) > "" then kill f2$
fc = 1
if srate% < 5000 then
	print using "Sample rate #### too low for standard Soundblaster, Increase this value   Y/n";srate%
	while not instat : wend
	if ucase$(inkey$) = "N" then exit if
	bitstuff% = int(5000 / srate%)
	srate% = srate% * (bitstuff% + 1)
	print using "Extra ### bits added to increase sampling rate to #####";bitstuff%,srate%
   fchz = srate% / 4
	locate 11 , 10
	print "Filter cutoff , Hz  <=  ";fchz;"   ";
	input ,newfchz
	if newfchz <= fchz and newfchz > 0 then fchz = newfchz
	fc = fchz / srate%
end if

locate 12 , 10
input "Amplitude scaling                   [1]  ",sf
if sf = 0 then sf = 1

locate 14 , 10 : color 15
print f1$;
color 31 : print "   >>>>  ";
color 15 : print f2$

for x% = 0 to 64           'generate 64 tap digital filtering coefficients
	y% = abs(32 - x%)
	th = y% * 2 * pi * fc
	if y% = 0 then	c = 1	else c = sin(th) / th      '  sin(x) / x
	c = c * (.54 - .46 * cos(2 * pi * x% / 64))		' Hamming window
	filtcoef(x%) = c
next

open "b" , 1 , f1$
open "b" , 2 , f2$
records& = lof(1)
locate 14 , 50
print records&;"Readings"
on timer(1) gosub progres
timer on
color 8 : locate 15 , 10
print string$(60 , 219);
riff$ = "RIFF" : put$ 2 , riff$
chunk& = (bitstuff% + 1) * records& + 36 : put 2 ,,  chunk&
wave$ = "WAVE" : put$ 2 , wave$
fmt$ = "fmt "  : put$ 2 , fmt$
size& =  16 : put 2 , 16 , size&
equals1% = 1 : put 2 , 20 , equals1%
channels% = 1 : put 2 , 22 , channels%
samplerate& = srate% : put 2 , 24 , samplerate&
BytesPerSec& = srate% : put 2 , 28 , BytesPerSec&
BytesPerSample% = 1 : put 2 , 32 , BytesPerSample%
BitsPerSample% = 8 : put 2 , 34 , BitsperSample%
seek 2 , 36
d$ = "data" : put$ 2 , d$
SizeOfData& = records& * (bitstuff% + 1) : put 2 ,, SizeOfData&

'should be at position in wav file for start of data
do
	for newbits% = 0 to bitstuff%
		if newbits% = 0 then
			get 1 ,, d?
		else
			d? = 128
		end if

		for x% = 1 to 64           'move last 64 readings back one
			last64(x% - 1 ) = last64(x%)
		next x%
		dz = 0
		last64(64) = d? - 128
		for x% = 0 to 64
			dz = dz + last64(x%) * filtcoef(x%)
		next x%

		if abs(sf * dz * max(bitstuff% , 1)) > 127 then
			print
			print
			color 15
			print "   Amplitude data out of range - run again using a lower scaling factor"
			color 7
			print
			end
		end if
		d? = sf * dz * max(bitstuff% , 1) + 128
		put 2 ,, d?
	next newbits%
	incr counter&
loop until eof(1)
close
cls
print "File  ";f2$;" Generated"
end

progres:
	color 3
	nchars% = counter& / records& * 60
	locate  15 , 10
	print string$(nchars% , 219);
	if inkey$ = chr$(27) then locate 21 , 1 : end
	timremain = (records& - counter&) / (counter& - lastcount&)
	lastcount& = counter&
	locate 17 , 27 : color 7
	print using "Time remaining #####s";timremain
return