defdbl a - z  'seems to make no difference to speed, remove for space in PB
cls
dim huge dat(16384) , dispdat(16383)
'dim huge dat(4096) , dispdat(4096)       'use when in IDE mode

dbscale = 60
dboffset = 0
colfact = 16
sigbins% = 2    '+/- from centre
wintype% = 1
noisecol% = 12
arrowcol% = 13
pi = 3.141592653589793238462643383279
screen 12
palette 6 , 6
locate 1 , 15 : color 14
print "Serial A/D converter spectrum analyser display"
color 11
locate 16 , 15
if command$ > "" and dir$(command$ + ".DAT") > "" then
	fromfile% = -1
	print "Using data from file ";ucase$(command$) + ".DAT"
else
	color 7 : print "Data from "; : color 12 : print "F"; :color 7 :print "ile  or  [";
	color 12 : print "R"; : color 7 : print "]eal time"
	while not instat : wend
	if ucase$(inkey$) = "F" then fromfile% = -1 else fromfile% = 0
end if

if fromfile% then
	color 7
	locate 3 , 1
	fi$ = command$
	if fi$ = "" then files("*.dat")
	locate 18 , 15 : color 11
	if fi$ = "" then input "File name  ", fi$
	if instr(fi$ , ".") = 0 then fi$= fi$ + ".dat"
	fi$ = ucase$(fi$)
	if dir$(fi$) = "" then
		sound 400 , 1
		print "No file"
		end
	end if
	finf$ = left$(fi$ , instr(fi$ , ".") - 1) + ".INF"
	locate 20 , 15
	if dir$(finf$) > "" then
		open "i" , 1 , finf$
		input #1 , basesamplerate
		close 1
      print using "Sampling rate #####";basesamplerate
	else
		input "Sampling rate   [10000] ",basesamplerate
		if basesamplerate = 0 then basesamplerate = 10000
	end if
	open "b" , 1 , fi$
else
	comport$ = environ$("DSPCOM")
	if comport$ = "" then
		sound 400 , 2
		print "Environment variable DSPCOM not set   eg. DSPCOM=2"
		end
	end if
   def seg = &h40
	comaddr% = peeki(2 * val(comport$) - 2)
	out comaddr% + 4 , 3         'set DTR and RTS for interface
	color 10 : locate 10 , 30
	print "Setting interface...."
	locate 16 , 1 : print space$(80);
	locate 30 , 25
	print "Interface on COM";comport$;"  Address ";hex$(comaddr%);
	locate 12 , 30
	print "Adjust input level..."
	CheckLevel
	locate 18 , 10
	color 15 : print "Sampling rate  Hz  ";
	color 12 : print tab(30);"1 "; : color 7 : print "  10000 Hz   100 us";
	color 12 : print tab(30);"2 "; : color 7 : print "   7143 Hz   140 us";
	color 12 : print tab(30);"3 "; : color 7 : print "   2500 Hz   400 us";
	while not instat : wend
	a$ = ucase$(inkey$)
	select case a$
	case "2"
		BaseSampleRate = 1e6 / 140
	case "3"
		BaseSampleRate = 2500
	case "1" , chr$(13)
		BaseSampleRate = 10000
	case else
		sound 400 , 1
		end
	end select
end if
locate 22 , 15
color 11
input "Decimation factor      (1)     ",decim%
if decim% = 0 then decim% = 1
locate 23 , 15
input "FFT Size    [1024]  ",nsamples%
if nsamples% = 0 then nsamples% = 1024
nsamples% = 2 ^ int((log(nsamples%) / log(2)) + .5)
samplerate =  BaseSampleRate / decim%
locate 24 , 15
input "Min,Max freqs to search (Full) ",fsearchmin,fsearchmax
if fsearchmin > fsearchmax then swap fsearchmin , fsearchmax

locate 25 , 15
input "FFT samples to average  (2)    ",avno%
if avno% = 0 then avno% = 2
if fromfile% then
	avplots% = int(lof(1) / nsamples% / decim% / avno%)
	if avplots% = 0 then avno% = int(lof(1) / nsamples% / decim%)
end if
locate 26 , 15
print using "Noise bandwidth for SNR   [####]  ";sigbins% * samplerate / nsamples% * 6;
input ,noiseband
if noiseband = 0 then noiseband = sigbins% * samplerate / nsamples% * 6
noisebins% = noiseband / samplerate / 2 * nsamples%
cls
gosub DoAction       'to set initial screen
on error goto errhndlr

do
	tim = timer       'to time rest of functions
	for av% = 1 to avno%
		if fromfile% then call ReadFromFile(nsamples%) _
					else call ReadAdc (nsamples%)
		if fromfile% and eof(1) then exit loop
		select case wintype%
		case 1
			call HammingWind(nsamples%)
		case 2
			call BlackHarrisWind(nsamples%)
		end select
		call FFT (nsamples% , 1)
		for k% = 1 to nsamples% step 2
			dispdat(k% \ 2)  = dat(k% - 1) ^ 2  + dat(k%)^ 2 + dispdat(k% \ 2)
		next k%
	next av%
   if instat then gosub DoAction
	cls graphics
	call DrawScale

	PeakHeight = 0
	lastplotx% = 0
	for k% = 0 to nsamples% / 2
		mag = (dispdat(k%) / avno% / nsamples% )
		s3% = s2% : s2% = s1% : s1% = s%
		s% = sgn(mag - lastone)
		if  k% >= mintestbin% and k% <= maxtestbin% then
			plcol% = 14
			if s% = -1 and s1% = 1 then       '1 rising then back down
				if lastone > PeakHeight then
					peakno% = k% - 1
					PeakHeight = lastone
				end if
			end if
		else
			plcol% = 2
		end if
      lastone = mag
		ploty% = 448 - dbscale * (log10((mag + 1))) + dboffset
		plotx% = k% / nsamples% * 1024 + 64
		line (lastplotx% , lastploty%) - (plotx% , ploty%) , plcol%
      lastploty% = ploty%
		lastplotx% = plotx%
	next k%
   color 15
	locate 1,60
	print using "Sample rate  ##### Hz";samplerate;
	locate 2,60
	print using "#### Bins   ###.## Hz";nsamples% , samplerate / nsamples%;
	locate 3 , 60
	select case wintype%
	case 0
		print "No window           "
	case 1
		print "Hamming window      "
	case 2
		print "Black. Harris Window"
	end select
   locate 4 , 60
	print using "Average over ###";avno%
	locate 5 , 60
	print using "Sig Band  #####.# Hz";(2 * sigbins% + 1) * samplerate / nsamples%
	locate 30 , 5 : print "0";
	locate 30 , 73 : print using "##### Hz";samplerate / 2;

	sigpower = 0
	totpower = 0

	for sl% = -sigbins% to sigbins%         'power in (2 * sigbins + 1) bins
		ks% = peakno% + sl%
		sigpower = sigpower + dispdat(ks%) / avno% / nsamples%
	next sl%

	for tp% = -noisebins% to noisebins%         'power in (2 * sigbins + 1) bins
		ks% = peakno% + tp%
		totpower = totpower + dispdat(ks%) / avno% / nsamples%
	next tp%
   NoiseBand = noisebins% * 2 * samplerate / nsamples%
	noise = totpower - sigpower
	snr = sigpower / noise
	refnoise = noise / noisebins% / 2

	plotpeakheight = 448 - dbscale * (log10((sigpower + 1) / sigbins%)) + dboffset
	plotpeakno% = peakno% / nsamples% * 1024 + 64
	plotnoise% = 448 - dbscale * (log10((refnoise + 1))) + dboffset

	'Draw peak signal arrow
	line (plotpeakno% - 4 , plotPeakHeight - 9) - (plotpeakno% , plotPeakHeight) , arrowcol%
	line (plotpeakno% , plotPeakHeight) - (plotpeakno% + 4 , plotPeakHeight - 9) , arrowcol%
	'Draw noise measurement band
	line (plotpeakno% - sigbins% - 1 , plotnoise%) - (plotpeakno% - sigbins% - noisebins%, plotnoise%) , noisecol%
	line (plotpeakno% + sigbins% + 1 , plotnoise%) - (plotpeakno% + sigbins% + noisebins%, plotnoise%) , noisecol%
	locate 30 , 15
	print using "####.## Hz  SNR = ###.# dB in ####.# Hz B/W";peakno% * samplerate / nsamples% ,10 * log10(snr), noiseband;
	
   samplerate = BaseSampleRate / decim%
	tim = timer - tim
	timetaken = tim
	for k% = 0 to nsamples% / 2
		dispdat(k%) = 0
	next k%
loop
window
view
if fromfile% then do
	while not instat : wend
		ik$ = ucase$(inkey$)
		if ik$ = chr$(27) then end
		if ik$ = chr$(0 , 59) then call MakeBMP("SPECT")
	loop
end
'========================================================================
sub ReadAdc (n%)
	shared decim% , comport$, comaddr% , dat()
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1 , dt , ds, cs , cd , me , fe" as 1 len = 30000
	for samplecount% = 1 to 2 * n% - 1 step 2
		for decimcount% = 1 to decim%
			do until loc(1) > 0
			loop
			a$ = input$(loc(1) , 1)
			value% = asc(a$) - 128
			if decimcount% = 1 then
				dat(samplecount%) = value%
				dat(samplecount% + 1) = 0
			else
				dat(samplecount%) = value% / decim% + dat(samplecount%)
				dat(samplecount% + 1) = 0
			end if
		next decimcount%
	next samplecount%
	close 1
	out comaddr% + 4 , 3
end sub
'========================================================================
sub ReadFromFile(n%)
	shared decim% , comport$, comaddr% , dat()
   for samplecount% = 1 to 2 * n% - 1 step 2
		for decimcount% = 1 to decim%
			get$ 1 , 1 , a$
			value% = asc(a$) - 128
			if decimcount% = 1 then
				dat(samplecount%) = value%
				dat(samplecount% + 1) = 0
			else
				dat(samplecount%) = value% / decim% + dat(samplecount%)
				dat(samplecount% + 1) = 0
			end if
		next decimcount%
	next samplecount%
end sub
'=======================================================================
sub FFT(nn% , isign%)          'isign% = 1 for FFT,  -1 for INV FFT
'data format  (re,im,re,im,....) starting at 1
	shared pi , dat()
	n% = 2 * nn%
	j% = 1
	for i% = 1 to n% step 2
		if j% > i% then
			swap dat(i%) , dat(j%)
			swap dat(i% + 1) , dat(j% + 1)
		end if
		m% = n% \ 2
		while m% >= 2 and j% > m%
			decr j% , m%
			shift right m% , 1            ' /2
		wend
		incr j% , m%
	next i%
	mmax% = 2

	while n% > mmax%
		istep% = 2 * mmax%
		theta = 2 * pi / (isign% * mmax%)
		wpr = cos(theta)
		wpi = sin(theta)
		wr = 1
		wi = 0
		for m% = 1 to mmax% step 2
			for i% = m% to n% step istep%
				j% = i% + mmax%
				tempr = wr * dat(j%) - wi * dat(j% + 1)
				tempi = wr * dat(j% + 1) + wi * dat(j%)
				dat(j%) = dat(i%) - tempr
				dat(j% + 1) = dat(i% + 1) - tempi
				incr dat(i%) , tempr
				incr dat(i% + 1) , tempi
			next i%
			wtemp = wr
			wr = wr * wpr - wi * wpi
			wi = wi * wpr + wtemp * wpi
		next m%
		mmax% = istep%
	wend
end sub
'================================================================================

sub DrawScale
	view screen (56 , 80) - (575 , 456)
	shared nsamples% , samplerate , dboffset , dbscale
	shared mintestbin% , maxtestbin%
	color 3
	maxheight = nsamples% * 64
	line (64 , 80) - (64 , 448) , 7
	line - (575 , 448) , 7
	line (575 , 556) - (575 , 80) , 7
	locate 29 , 38
	if samplerate <= 2000 then
		plint% = 10
		hi% = 100
	else
		plint% = 100
		hi% = 1000
	end if
	for freq = 0 to samplerate / 2 step plint%
		if freq mod hi% = 0 then
			patt% = &hFFFF
			ystart% = 454
			colgrid% = 7
		else
			patt% = &hF0F0
			ystart% = 448
			colgrid% = 8
		end if
		xposn% = freq / samplerate * 1024 + 64
		line (xposn% , ystart%) - (xposn% , 80) , colgrid% ,, patt%
	next freq
	for db% = 0 to dbscale * 1.5 step 2
		y = 448 - dbscale * db% / 10
		if db% mod 10 = 0 then
			patt% = &hFFFF
			xstart% = 56
			colgrid% = 7
		else
			patt% = &hF0F0
			xstart% = 64
			colgrid% = 8
		end if
		line (xstart% , y) - (575 , y) , colgrid% ,, patt%
	next db%
	locate 15 , 1 : print " 10 dB ";
	view screen (64 , 80) - (575 , 448)
end sub
'================================================================

sub HammingWind (n%)
	shared pi , dat()
	for k% = 0 to n% - 1
		locdat% = k% * 2 + 1
		dat(locdat%) = dat(locdat%) * (1 - .851852 * cos(2 * pi * k%/ n%))
		dat(locdat% + 1) = dat(locdat% + 1) * (1 - .851852 * cos(2 * pi * k%/ n%))
	next k%
end sub

sub BlackHarrisWind (n%)
	shared pi , dat()
	for k% = 0 to n% - 1
   	locdat% = k% * 2 + 1
		theta = 2 * pi * k% / n%
		dat(locdat%) = dat(locdat%) * (.42323 - .49755 * cos(theta)_
											 + .07922 * cos(2 * theta)) / .42
		dat(locdat% + 1) = dat(locdat% + 1) * (.42323 - .49755 * cos(theta)_
											 + .07922 * cos(2 * theta)) / .42
	next k%
end sub
'=================================================================
sub CheckLevel
	shared comport$, comaddr%, dat()
	close 1   'since probably already open
	for t% = 0 to 4095
		dat(t%) = 0
	next t%
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1, ds, cs , cd , me , fe" as 1 len = 30000
	line (191 , 230) - (191 , 254) , 10
	line (449 , 230) - (449 , 254) , 10
	do
		do until loc(1) > 0
			if instat then ik$ = inkey$
		loop
      if ik$ = chr$(27) then end
		a$ = input$(loc(1) , 1)
		value% =  abs(asc(a$) - 128)
		if value% > 90 then
			line (320 + value% , 235) - (320 + value% , 248) , 3
			line (320 - value% , 235) - (320 - value% , 248) , 3
		end if
		if value% > 126 then co% = 12	else co% = 11
		line (192 , 240) - (448 , 243) , 0 , bf
		line (320 - value% , 240) - (320 + value% , 243) , co% , bf
		if instat then ik$ = ucase$(inkey$)
		if ik$ = "C" then line (192 , 235) - (448 , 248) , 0 , bf : ik$ = ""
		loop until ik$ = chr$(27)
	if inkey$ = chr$(27) then end
	close 1
   out comaddr% + 4 , 3
end sub
'=========================================================================
sub GreyPalette
	for co% = 0 to 15
		palette co% , co%
		rgb% = co% * 4 + 3
		reg 1 , &h1010
		reg 2 , co%
		reg 3 , 256 * rgb% + rgb%
		reg 4 , rgb% * 256
		call interrupt &h10
	next co%
end sub

sub ShowCols
	for co% = 0 to 15
		locate 20 - co% , 80
		color co%
		print "";
	next co%
end sub
'===========================================================================
DoAction:
	select case ucase$(inkey$)
	case chr$(27)
		end
	case "+"
		nsamples% = min (nsamples% * 2 , 8192)
		newwind% = -1
	case "-"
		nsamples% = max (nsamples% / 2 ,8)
		newwind% = -1
	case "W"
		incr wintype%
		wintype% = wintype% mod 3
	case "D"
		decim% = decim% + 1
		clscn% = -1
	case chr$(4)
		decim% = max(decim% -1 , 1)
		clscn% = -1
	case "B"
		dboffset = dboffset + 5
	case  chr$(2)
		dboffset = dboffset - 5
	case "S"
		dbscale = dbscale / 1.05
	case chr$(19)
		dbscale = dbscale * 1.05
	case "R"
		clscn% = -1
	case "K"
		if not fromfile% then CheckLevel
		newwind% = -1
	case "M"
		call GreyPalette
	case "C"
		colfact = colfact * 1.2
	case chr$(3)
		colfact = colfact / 1.2
	case "V"
		avno% = 2 * avno%
	case chr$(22)
		avno% = max(avno% / 2 , 1)
	case "G"
		if sigbins% > 10 then sigbins% = sigbins% * 1.2 else incr sigbins%
	case chr$(7)
		if sigbins% > 12 then sigbins% = sigbins% / 1.2 else sigbins% = max(sigbins% - 1 , 1)
	case "N"
   	if noisebins% > 10 then noisebins% = noisebins% * 1.2 else incr noisebins%
	case chr$(14)
		if noisebins% > 12 then noisebins% = noisebins% / 1.2 else noisebins% = max(noisebins% - 1 , sigbins% * 2)
	case chr$(0 , 59)
		window
		view
		call MakeBMP("SPECT")
	end select
	if noisebins% < 3 * sigbins% then noisebins% = sigbins% * 3

	view screen (56 , 80) - (575 , 456)
	color 11
	locate 1 , 1 : print "+ / -      No of bins     B / ctl-B  Baseline"
	locate 2 , 1 : print "D / ctl-D  Decimation     S / ctl-S  Scale"
	locate 3 , 1 : print "W          Window type    G / ctl-G  Signal B/W"
	locate 4 , 1 : print "V / ctl-V  Averaging      N / ctl-N  Noise  B/W"
	locate 5 , 1 : print "F1  .BMP File"

	clscn% = 0
	newwind% = 0
	if fsearchmin = 0 and fsearchmax = 0 then
		mintestbin% = 0
		maxtestbin% = nsamples% / 2
	else
		mintestbin% = fsearchmin / Basesamplerate * nsamples% * decim%
		maxtestbin% = fsearchmax / Basesamplerate * nsamples% * decim%
		locate 5 , 1 : print using "Peak search #### to #### Hz";fsearchmin,fsearchmax
	end if
return

errhndlr:
	resume next

sub MakeBmp(basename$)       'Palette table assumes EGA compatibility
	filename$ = dir$(basename$ + "???.bmp")
	n% = val(mid$(filename$ , 6, 3))
	do
		f$ = dir$
		n% = max(val(mid$(f$ , 6, 3)) , n%)
	loop until f$ = ""
	n$ = mid$(str$(min(n% + 1, 999)) , 2)
	do while len(n$) < 3
		n$ = "0" + n$
	loop
	f$ = basename$ + n$ + ".BMP"
	bwidth& = 640           'previously set by   PALETTE CO%,CO%
	bheight& = 480
	ColoursInTable& = 16
	BitsPerPixel% = 4        '1 / 4 / 8 / 24  only
	NPlanes% = 1             '1 only
	InfoSize& = 40

	ImageSize& = bwidth& * bheight& * BitsperPixel% / 8
	dataoffset& = 54 + ColoursInTable& * 4
	filesize& = dataoffset& + ImageSize&

	t = timer
	if instr(ucase$(f$) , ".BMP") = 0 then f$ = f$ + ".BMP"
	fi% = freefile
	open "b" , fi% , f$
	i1% = 0 : i2% = 0 : compression& = 0
	bm$ = "BM"
	put$ fi% , bm$
	put fi% , 2 , filesize&
	put fi% ,, i1%
	put fi% ,, i2%
	put fi% ,, DataOffset&
	put fi% ,, InfoSize&
	put fi% ,, bwidth&
	put fi% ,, bheight&
	put fi% ,, NPlanes%
	put fi% ,, BitsPerPixel%
	put fi% ,, compression&
	put fi% ,, ImageSize&
	put fi% ,, XPelsPerMetre&
	put fi% ,, YPelsPerMetre&
	put fi% ,, ColoursInTable&
	put fi% ,, ImportantColours&

	seek fi% , 54
	for rgb% = 0 to 15
		reg 1 , &h1015
		reg 2 , rgb%
		call interrupt &h10
		b% = (reg(3) mod 256) * 4
		g% = (reg(3) \ 256) * 4
		r% = (reg(4) \ 256) * 4
		pa$ = chr$(b%) + chr$(g%) + chr$(r%) + chr$(0)
		put$ fi% , pa$
	next rgb%

	seek fi% , dataoffset&         'data starts at bottom left of picture
	nibble% = 0
	for y% = bheight& - 1 to 0 step -1
		dat$ = ""
		for x% = 0 to bwidth& - 2 step 2
				d% = 16 * point (x% , y%) + point (x% + 1 , y%)
				dat$ = dat$ + chr$(d%)
		next x%
      put$ fi% , dat$
	next y%
	close fi%
	sound 1750 , 2
end sub